#include "a_gsl_bfgs.h"
#include <omp.h>
#include <cstdlib>
#include "tolmin.h"
/*
a_gsl_bfgs::a_gsl_bfgs(nikolas::rnn **p,Data &initialx,int max,Dataset *tr)
{
    pf = p;
    d = tr;
    maxSteps = max;
    xm = initialx;
    x1 = gsl_vector_alloc(xm.size());
    dweights = new double [xm.size()];
    prive = new nikolas::rnn(p[0]->getLexicSize(),p[0]->getHiddenSize());
}

a_gsl_bfgs::~a_gsl_bfgs(){
    delete [] dweights;
    gsl_vector_free(x1);
    delete prive;
}*/


adouble comp(vector<adept::adouble> &x, nikolas::rnn *pf,Dataset *d){
    adouble retVal = 0.0;
    adouble total = 0;
    pf->setParameters(x);
    for(int i = 0; i <  double(d->positiveLines(TrainData));i++){
        retVal += adouble( pf->acomputeFit(d->getPositiveLine(i,TrainData)) );
        total += adouble(d->getPositiveLine(i,TrainData).size()-1.0);
    }
    for(int i = 0; i <double(d->negativeLines(TrainData));i++){
        retVal += adouble(d->getNegativeLine(i,TrainData).size() - pf->acomputeFit(d->getNegativeLine(i,TrainData)));
        total += adouble(d->getNegativeLine(i,TrainData).size()-1.0);
    }
    return  retVal/(total);
}
adouble comp(vector<adept::adouble> &x, Params *p){
    adouble retVal = 0.0;
    adouble total = 0;
    nikolas::rnn *pf = p->r;
    pf->setParameters(x);
    Dataset *d = p->d;
    for(int i = 0; i <  double(d->positiveLines(TrainData));i++){
        retVal += pf->acomputeFit(d->getPositiveLine(i,TrainData));
        total += adouble(d->getPositiveLine(i,TrainData).size())-1.0;
    }
    for(int i = 0; i <double(d->negativeLines(TrainData));i++){
        //pf[omp_get_thread_num()]->setParameters(x);
        retVal += (d->getNegativeLine(i,TrainData).size() - pf->acomputeFit(d->getNegativeLine(i,TrainData)));
        total += adouble(d->getNegativeLine(i,TrainData).size())-1.0;
    }
    //std::cout << retVal/total << " " << retVal << "/" << total << " ";
    //return retVal;
    return  retVal/(total);
}

void setAdeptGrad(double *grad,Params *p){
    using adept::adouble;
    std::vector<adouble> gr(p->size);
    //gr.resize(newW.size());
    for(unsigned i = 0; i < p->xm.size();i++) gr[i] = p->xm[i];
    p->stack->new_recording();
    adouble y = comp(gr,p);
    y.set_gradient(1.0);
    p->stack->compute_adjoint();
    //stack.compute_tangent_linear();
    for(unsigned i = 0; i < gr.size();i++){
        grad[i] = gr[i].get_gradient() ;
    }
    p->stack->clear_gradients();
    //std::cout << std::endl;
}

double getFunmin(vector<double> &x,nikolas::rnn **pf,Dataset *d)
{
    double retVal = 0.0;
    int total = 0;
    pf[omp_get_thread_num()]->setParameters(x);
    for(unsigned i = 0; i < double(d->positiveLines(TrainData));i++){
        retVal += pf[omp_get_thread_num()]->computeFit(d->getPositiveLine(i,TrainData));
        total += d->getPositiveLine(i,TrainData).size()-1;
    }
    for(unsigned i = 0; i < double(d->negativeLines(TrainData));i++){
        retVal += (d->getNegativeLine(i,TrainData).size() - pf[omp_get_thread_num()]->computeFit(d->getNegativeLine(i,TrainData)));
        total += d->getNegativeLine(i,TrainData).size()-1;
    }
    return retVal/(1.0*total);
}

/*
double getFit(const gsl_vector * x, void * params){
    nikolas::rnn *pf = ((Params *)params)->r;
    Dataset *d = ((Params *)params)->d;
    Data xm(x->size);
    for(unsigned i = 0; i < x->size;i++) xm[i] = gsl_vector_get(x, i);
    pf->setParameters(xm);
    double retVal = 0.0;
    int total = 0;
    for(unsigned i = 0; i < double(d->positiveLines(TrainData));i++){
        retVal += pf->computeFit(d->getPositiveLine(i,TrainData));
        total += d->getPositiveLine(i,TrainData).size()-1;
    }
    for(unsigned i = 0; i < double(d->negativeLines(TrainData));i++){
        retVal += (d->getNegativeLine(i,TrainData).size() - pf->computeFit(d->getNegativeLine(i,TrainData)));
        total += d->getNegativeLine(i,TrainData).size()-1;
    }
    return retVal/(1.0*total);
}*/

void	getGranal(vector<double> &x,nikolas::rnn **pf,Dataset *d,vector<double> &g, MinInfo &I)
{
    //pf[omp_get_thread_num()]->setParameters(x);
    using adept::adouble;
    //adept::Stack stack;
    //nikolas::rnn prive(pf[0]->getLexicSize(),pf[0]->getHiddenSize());
    std::vector<adouble> gr(x.size());
    for(unsigned i = 0; i < x.size();i++) gr[i] = x[i];
    I.s->continue_recording();
    I.s->new_recording();
    adouble y = comp(gr,I.r,d);
    y.set_gradient(1.0);
    I.s->compute_adjoint();
    for(unsigned i = 0; i < gr.size();i++){
        g[i] = gr[i].get_gradient() ;
        //std::cout << g[i] << " ";
    }
    //std::cout << std::endl;
    I.s->clear_gradients();
    I.s->pause_recording();
    //delete prive;
}
/*
void getdFit(const gsl_vector * x, void * params, gsl_vector * g){
    nikolas::rnn *pf = ((Params *)params)->r;
    Dataset *d = ((Params *)params)->d;
    Data xm(x->size);
    for(unsigned i = 0; i < x->size;i++) xm[i] = gsl_vector_get(x, i);
    pf->setParameters(xm);
    double *dweights = new double[((Params *)params)->size];
    setAdeptGrad(dweights,(Params *)params);
    for(unsigned i=0;i<xm.size();i++) gsl_vector_set(g, i, dweights[i]);
    delete [] dweights;
}

void getFitdFit(const gsl_vector *x, void *params,
        double *f, gsl_vector *df)
{
  *f = getFit(x, params);
  getdFit(x, params, df);
}*/
/*
Data a_gsl_bfgs::getResults(){
    return xm;
}

void a_gsl_bfgs::run(){
    //gsl_multimin_fdfminimizer_vector_bfgs2
    gsl_multimin_function_fdf my_func;
    const gsl_multimin_fdfminimizer_type *T;
    gsl_multimin_fdfminimizer *s;
    Params *p = new Params;
    p->d = this->d;
    p->r = this->prive;
    p->size = unsigned(this->xm.size());
    p->xm = this->xm;
    p->stack = &this->stack;
    my_func.n = xm.size();
    my_func.f = getFit;
    my_func.df = getdFit;
    my_func.fdf = getFitdFit;
    my_func.params = (void *)p;
    for(unsigned i = 0; i < xm.size();i++) gsl_vector_set (x1, i, xm[i]);
    T = gsl_multimin_fdfminimizer_vector_bfgs;
    s = gsl_multimin_fdfminimizer_alloc(T, x1->size);
    double eps1=1e-3;
    double eps2=1e-3;
    gsl_multimin_fdfminimizer_set(s, &my_func, x1, eps1,eps2);
    std::cout << "Before BFGS : "  << getFit(s->x,p) << std::endl;
	double mymin=1e+10;
	
    for(unsigned i = 0; i < maxSteps;i++){
        if( gsl_multimin_fdfminimizer_iterate(s)) break;
        if(gsl_multimin_test_gradient(s->gradient, 0.0000) == GSL_SUCCESS) break;
        double xf=getFit(s->x,p);
        if(Vars.verbose) std::cout << "ITER : " << i << " FIT : " << s->f << " Thread: " << omp_get_thread_num() << "\n";
	if(xf<mymin)
	{
        	for(unsigned i = 0; i < xm.size();i++) {
            		xm[i] = gsl_vector_get(s->x, i);
        	}
		mymin=xf;
	}
    }
    gsl_multimin_fdfminimizer_free (s);
    delete p;
}*/




