#ifndef CLASSIFIER_H
#define CLASSIFIER_H

#include "improved_rnn.h"
#include "dataset.h"
#include "stdbool.h" // memory optimization for bool vectors

class Classifier{
public:
    // The RnInst must have set weights
    Classifier(nikolas::rnn *RnInst, Dataset *trainD);
    ~Classifier();
    void setWeights(int pos, float val);
    void setRnn(nikolas::rnn *r);
    void computeThreshold();
    void printResults();
    // pos = 0, TP = val | pos = 1, FP = val | pos = 2, FN = val | pos = 3, TN = val
    void writeResults(vector<float> &TP,vector<float> &TN );
private :
    void computeProbs();
    nikolas::rnn *Rnn; // all the Rnns for multithreading
    Dataset *d;
    float ClassWeights[2][2] = {{1,1},{1,1}};
    float TestResults[2] = {0,0};
    bool *results;
    float *logProbs;
    float *logProbsSorted;
    float thresh;
};

#endif // CLASSIFIER_H
