#ifndef DATASET_H
#define DATASET_H
# include <stdio.h>
# include <string.h>
# include <vector>
# include <string>
# include <set>
# include <map>
# include <optionsparser.h>

using namespace  std;

typedef char SYMBOL;
typedef vector<unsigned> LINE;
extern GlobalVars Vars;
enum {TrainData = 0, TestData = 1};

class Dataset
{
private:
    set<SYMBOL> vocabulary;
    vector<SYMBOL> intToSymbol;
    map<SYMBOL,unsigned> symbolToInt;
    vector<LINE> posData;//positive data
    vector<LINE> negData;//negative data
    //test data
    vector<LINE> testPosData;
    vector<LINE> testNegData;
    //levenshtein
    unsigned maxLen;
    void addSymbolsToVocabulary(LINE &input);
    void buildDictionary();
public:
    Dataset(char *filename);
    int vocabularySize();
    int positiveLines(int DataSet = TrainData) const;
    int negativeLines(int DataSet = TrainData) const;
    unsigned getMaxLen() const;
    const LINE &getPositiveLine(int pos,int DataSet = TrainData) const;
    const LINE &getNegativeLine(int pos,int DataSet = TrainData) const;
    unsigned int  symbolCode(SYMBOL c);
    vector<unsigned> lineToCode(LINE &l);
};

#endif // DATASET_H
