#ifndef GENETIC_H
#define GENETIC_H
#include <dataset.h>
# include <pso.h>
#include <optionsparser.h>
#include "improved_rnn.h"
#include "classifier.h"
#include "adept.h"

extern GlobalVars Vars;

typedef vector<double> Data;

class Genetic
{
private:
    nikolas::rnn *rnn2;
    nikolas::rnn **rnn3;
    Classifier *c;
    Dataset *train;
    vector<Data> chromosome;
    vector<Data> children;
    vector< vector<double> > results;
    vector<vector<float>> ClassResults;
    Data fitnessArray;
    double selection_rate,mutation_rate;
    int    generation;
    int numThreads;
    Data    tempx;
    void    calcFitnessArray();
    void    selection();
    void    crossover();
    void    mutation();
    int     tournament();
    void    localSearch(int pos);
    adept::Stack *stack;
public:
    Genetic(nikolas::rnn *r,Dataset *t,int count,int numthreads = 10);
    ~Genetic();
     double  fitness(Data &x, unsigned net = 0);
     double NaiveAccuracy(Data &x, int DataSet = TrainData, unsigned net = 0); // percentage of correct letters
     double ProbAccuracy(Data &x, int DataSet = TrainData, unsigned net = 0);
     double NegativeNaive(Data &x, int DataSet = TrainData, unsigned net = 0);
     double NegativeProb(Data &x, int DataSet = TrainData, unsigned net = 0);
     double fast_fitness(Data &x, unsigned net = 0);
      void    granal(Data &x,Data &g);
    int     getChromosomes() const;
    double  getSelectionRate() const;
    void    setSeletionRate(double r);
    double  getMutationRate() const;
    void    setMutationRate(double r);
    void    nextGeneration();
    int     getGeneration() const;
    void    getBest(Data &x,double &y);
    void    setBest(Data &x,double &y);
    void	bfgs(int pos);
    void printResults();
};

#endif // GENETIC_H
