#ifndef OPTIONSPARSER_H
#define OPTIONSPARSER_H

#include <string>
#include <fstream>
#include <unistd.h>
#include <iostream>
# include <QString>

enum {Uniform = 0, Crossover = 1, AdaGrad=2, Tolmin=3,Adam=4};


typedef struct globalVars{
    bool verbose=true;
    double selectionRate = 0.9;
    double mutationRate = 0.05;
    int     psoParticles=100;
    int     psoGenerations=100;
    int     adamIterations=1000;
    double  psoSphere=1.5;
    int     numberOfWeights=10;
    int     numberOfThreads=4;
    int     bfgsIters=200;
    int   randomSeed=1;
    int LocalSearch = 20;              // every how many iterations, local search is activated
    int LocalSearchTries = 10;         // how many children will be included in local search
    QString  filename = "data.txt"; // dataset name
    size_t generations = 300;          // number of iterations
    size_t populous = 500;             // number of individuals
    int LocalMethod = Tolmin;               // The kind of method used for local optimization
    int errorMetric = 0;               // preserved for selecting later which error function to use
} GlobalVars;


inline bool checkfile(const std::string name) {
    std::ifstream f(name.c_str());
    return f.good();
}

#endif // OPTIONSPARSER_H
