#ifndef PSO_H
#define PSO_H
# include <improved_rnn.h>
typedef vector<double> Data;


class Pso
{
	private:
    int generation;
    int generations;
        nikolas::rnn **problem;
        Dataset *train;
		int		iters;
        unsigned numThreads;
        Data		xbest;
		Data		lmargin;
		Data		rmargin;
		Data		center;
		double		ybest;
		vector<Data>	genome;
		vector<Data>	bestGenome;
		vector<Data>	vel;
		int		bestIndex;
		Data		fitness;
		Data		bestFitness;
		Data		oldBestFitness;
		void		calcFitnessArray();
		double		getInertia(int index);
		void		boundVelocity(double &v,int index);
		void		updateBest();
		void		updateCenter();
		double		x1,x2,stopat,oldbest,variance;
		void		calculateTerminationRule();
        double      fitnessFunction(Data &x,unsigned net = 0);
	public:
        Pso(nikolas::rnn **p,Data &initialx,int count,Dataset *tr, unsigned Threads = 10);
		bool    newGenerationFlag;
		void	Solve(int g,int iprint);
		void	nextGeneration();
		int	getGeneration();
		int	getGenomeCount();
		int	getDimension();
		void	getBest(Data &x,double &y);
		void	setBest(Data &x,double y);
		bool	terminationRule();
		~Pso();
};
//extern void localSearch(Problem *p,Data &x,double &y);
# endif
